#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR DATA FILES  

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use psfp;
use Time::Local; 
use obbuild;

&get_setup;
$q = CGI->new;

acs::check_access($username, $password, $q->param('username'), $q->param('password'));

$default_permissions = 0777; ### PERMISSIONS THAT IS USED FOR TEMPORARY DATA FILES 

##################################################################################

print "Content-type: text/html\n\n";
if ($q->param('fct') eq "") {&start;}
if ($q->param('fct') eq "save_webbuild_settings") {&save_webbuild_settings;}
if ($q->param('fct') eq "save_telnetssh_build_settings") {&save_telnetssh_build_settings;}

#############################################################

sub save_telnetssh_build_settings
{

$tel_build = $q->param('bseconds');
open (WBB, "> $data_dir/tel_build.cfg");
	print WBB $tel_build;
close (WBB);
chmod($default_permissions,"$data_dir/tel_build.cfg","$data_dir/tel_build.cfg");

&saved;

}




sub save_webbuild_settings
{

$number_of_cats = $q->param('number_of_cats');
$bseconds = $q->param('bseconds');


open (WBB, "> $data_dir/web_build.cfg");
	print WBB $number_of_cats . "\n";
	print WBB $bseconds;
close (WBB);
chmod($default_permissions,"$data_dir/web_build.cfg","$data_dir/web_build.cfg");

&saved;

}






sub saved
{

$hbox = acs::get_heading_box("$web_url/ic_settings4.gif", "Settings Saved", qq[You may <a href="javascript:onClick=window.close()">close</a> this window.]);

print <<END_OF_SAVED;

<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox
</body>
</html>

END_OF_SAVED

}




sub start
{

$web_build = acs::get_file_contents("$data_dir/web_build.cfg");
$tel_build = acs::get_file_contents("$data_dir/tel_build.cfg");
$tel_build =~ s/\n//g;

@wb_vars = split(/\n/, $web_build);


if ($tel_build eq "") { $tel_build = "0"; }

if ($wb_vars[0] eq "") { $wb_vars[0] = "5"; }
if ($wb_vars[1] eq "") { $wb_vars[1] = "1"; }

$selbox[$wb_vars[0]] = "selected";


$hbox = acs::get_heading_box("$web_url/ic_settings4.gif", "HTML Generation Resource Usage", qq[PowerSeek can use a lot of server resources when you generate HTML files. You can slow down the generation process to conserve server resource usage with the settings provided in this section. Use the settings below to slow down the build process so that there are less load on the MySQL server or less queries in frequency.]);



##################

print <<END_OF_STR;


<html>
<head>
<title>PowerSeek</title>
<link href="$web_url/ps.css" rel="stylesheet" type="text/css" />  
</head>
<body>
$hbox


<form method="POST" action="$admin_url/admin50.cgi">
  <table border="0"
  cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="766" colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>Browser Based HTML Generation
      Resource Usage Settings </strong></td>
    </tr>
    <tr>
      <td width="144" valign="top" bgcolor="#FFFFFF" class="normaltext">Number of categories to build per browser
      window? </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><select name="number_of_cats" size="1">
        <option $selbox[1] value="1"> 1 </option>
        <option $selbox[2] value="2"> 2 </option>
        <option $selbox[3] value="3"> 3 </option>
        <option $selbox[4] value="4"> 4 </option>
        <option $selbox[5] value="5"> 5 </option>
      </select> <br>
      When you build categories via the web browser, a number of categories is being built each
      time the browser window is refreshed. Set this to 1 for lowest resource usage. Set this to
      a higher number for faster builds. </td>
    </tr>
    <tr>
      <td width="144" valign="top" bgcolor="#FFFFFF" class="normaltext">Number of seconds to wait for each browser
      refresh window: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="bseconds" size="5"
      value="$wb_vars[1]"> Seconds <br>
      The default setting is 1 second. Increase the number for lower resource usage. </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="   Save   " name="B1">
        <input type="hidden" name="fct" value="save_webbuild_settings"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_</font> </td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

<form method="POST" action="$admin_url/admin50.cgi">
  <table border="0"
  cellspacing="1" width="100%" cellpadding="6" bgcolor="#DDDDDD">
    <tr>
      <td width="780" height="30" colspan="2" background="$web_url/bar6.gif" class="normaltext"><strong>Telnet/SSH HTML
      Generation Resource Usage Settings </strong></td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext">Number of seconds to wait after each category build: </td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="text" name="bseconds" size="5"
      value="$tel_build"> Seconds <br>
      The default setting is 0 seconds (No delay). Increase the number for lower resource usage.      </td>
    </tr>
    <tr>
      <td width="144" bgcolor="#FFFFFF" class="normaltext"></td>
      <td width="622" bgcolor="#FFFFFF" class="normaltext"><input type="submit" value="   Save   " name="B1">
        <input type="hidden" name="fct" value="save_telnetssh_build_settings"></td>
    </tr>
  </table>
  <table border="0" cellpadding="0" cellspacing="0" width="100%"
  background="$web_url/shadow.gif">
    <tr>
      <td width="1%" bgcolor="#FFFFFF"><font color="#FFFFFF">_ </font></td>
      <td width="99%"></td>
    </tr>
  </table>
</form>

</body>
</html>

END_OF_STR

}








sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

